<template>
  <div id="app">
    <Header />
    <Title v-bind:tasks="tasks"/>
    <AddTask v-on:add-task="addTask" />
    <div class="task-wrapper">
      <a-spin v-show="tasks.length === 0" />
      <TaskManager v-show="tasks.length > 0" v-bind:tasks="tasks" v-on:del-task="deleteTask" />
    </div>
  </div>
</template>

<script>
  import Vue from 'vue';
  import { Spin } from "ant-design-vue";
  import Header from './components/layout/Header';
  import Title from './components/share/Title';
  import AddTask from './components/AddTask';
  import TaskManager from './components/TaskManager';

  const tasks = [
    {
      id: 1,
      name: "Multimedia homework",
      completed: false
    },
    {
      id: 2,
      name: "English essay",
      completed: false
    },
    {
      id: 3,
      name: "Modern History research task",
      completed: false
    },
    {
      id: 4,
      name: "Clean room",
      completed: false
    },
    {
      id: 5,
      name: "Science study",
      completed: false
    },
    {
      id: 6,
      name: "Read 1 chapter novel",
      completed: false
    },
  ];

  export default {
    name: 'App',
    components: {
      Header,
      Title,
      AddTask,
      TaskManager,
      'a-spin': Spin
    },
    data() {
      return {
        tasks: [],
        info: null
      }
    },
    methods: {
      addTask(task) {
        this.tasks.push(task);
      },
      deleteTask(id) {
        this.tasks = this.tasks.filter(task => task.id !== id);
      }
    },
    created() {
      try {
        Vue.axios.get('https://www.mocky.io/v2/5185415ba171ea3a00704eed').then((response) => {
          this.info = response.data.hello;
          this.tasks = tasks;
        })
      } catch {
        this.tasks = tasks;
      }
    }
  }
</script>

<style>
  @import url('https://fonts.googleapis.com/css2?family=Staatliches&display=swap');
  @import url('https://fonts.googleapis.com/css2?family=Anton&family=Montserrat:wght@100;200;300;400;500;600;700;800;900&display=swap');
  body {
    background-color: #8EC5FC;
    background-image: linear-gradient(62deg, #8EC5FC 0%, #E0C3FC 100%);
    font-family: 'Montserrat', sans-serif;
    padding: 2rem;
  }
  #app {
    background: white;
    border-radius: 10px;
    padding: 2rem;
  }
  @media (min-width: 1200px) {
    #app {
      max-width: 60%;
      margin: 0 auto;
    }
  }
  @media (max-width: 768px) {
    body, #app {
      padding: 1rem;
    }
  }
  .ant-col {
    width: 100%;
  }
  .task-wrapper {
    position: relative;
    min-height: 10rem;
  }
  .ant-spin {
    position: absolute !important;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
  }
</style>
